﻿using System;
using System.Net;
using System.Runtime.Serialization;

namespace FMK.EFH.API.Sample
{
    [Serializable]
    public class ApiException : ApplicationException
    {
        public ApiException()
        {
            Model = new ApiExceptionModel();
        }

        public ApiException(string message)
            : base(message)
        {
            Model = new ApiExceptionModel();
        }

        public ApiException(string message, HttpStatusCode statusCode)
            : base(message)
        {
            Model = new ApiExceptionModel();
            Model.Message = message;
            Model.StatusCode = statusCode;
        }

        public ApiException(string message, Exception innerException)
            : base(message, innerException)
        {
            Model = new ApiExceptionModel();
            Model.Message = message;
        }

        protected ApiException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
            Model = info.GetValue("Model", typeof(ApiExceptionModel)) as ApiExceptionModel;
            if (Model == null)
                Model = new ApiExceptionModel();
        }

        public override void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            info.AddValue("Model", Model);
            base.GetObjectData(info, context);
        }

        public ApiExceptionModel Model { get; set; }
    }
}
